<?php

declare(strict_types=1);

namespace Pinpoint\ValidateZipUK\Plugin\Checkout;

use Magento\Checkout\Block\Checkout\LayoutProcessor;

class LayoutProcessorPlugin
{
    /**
     * Update postcode validation
     *
     * @param LayoutProcessor $processor
     * @param array $result
     * @param $jsLayout
     * @return array
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterProcess(
        LayoutProcessor $processor,
        array $result,
        $jsLayout
    ): array {
        // Adding special validation rule for UK zipcodes to the shipping address postcode field
        if (isset($result['components']['checkout']['children']['steps']['children']['shipping-step']['children']
            ['shippingAddress']['children']['shipping-address-fieldset']['children']['postcode'])) {
            $result['components']['checkout']['children']['steps']['children']['shipping-step']['children']
            ['shippingAddress']['children']['shipping-address-fieldset']['children']['postcode']['validation'] = [
                'required-entry' => true,
                'validate-zip-uk' => true,
            ];
        }
        return $result;
    }
}
